001 /*
002 * Sonar, open source software quality management tool.
003 * Copyright (C) 2008-2011 SonarSource
004 * mailto:contact AT sonarsource DOT com
005 *
006 * Sonar is free software; you can redistribute it and/or
007 * modify it under the terms of the GNU Lesser General Public
008 * License as published by the Free Software Foundation; either
009 * version 3 of the License, or (at your option) any later version.
010 *
011 * Sonar is distributed in the hope that it will be useful,
012 * but WITHOUT ANY WARRANTY; without even the implied warranty of
013 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
014 * Lesser General Public License for more details.
015 *
016 * You should have received a copy of the GNU Lesser General Public
017 * License along with Sonar; if not, write to the Free Software
018 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02
019 */
020 package org.sonar.wsclient.services;
021
022 import java.util.Date;
023
024 /**
025 * @since 2.2
026 */
027 public abstract class AbstractQuery<MODEL extends Model> {
028
029 /**
030 * Must start with a slash, for example: /api/metrics
031 * <p>
032 * IMPORTANT: In implementations of this method we must use helper methods to construct URL.
033 * </p>
034 *
035 * @see #encode(String)
036 * @see #appendUrlParameter(StringBuilder, String, Object)
037 * @see #appendUrlParameter(StringBuilder, String, Object[])
038 * @see #appendUrlParameter(StringBuilder, String, Date, boolean)
039 */
040 public abstract String getUrl();
041
042 /**
043 * Request body. By default it is empty but it can be overridden.
044 */
045 public String getBody() {
046 return null;
047 }
048
049 /**
050 * Encodes single parameter value.
051 */
052 protected static String encode(String value) {
053 return WSUtils.getINSTANCE().encodeUrl(value);
054 }
055
056 protected static void appendUrlParameter(StringBuilder url, String paramKey, Object paramValue) {
057 if (paramValue != null) {
058 url.append(paramKey)
059 .append('=')
060 .append(encode(paramValue.toString()))
061 .append('&');
062 }
063 }
064
065 protected static void appendUrlParameter(StringBuilder url, String paramKey, Object[] paramValues) {
066 if (paramValues != null) {
067 url.append(paramKey).append('=');
068 for (int index = 0; index < paramValues.length; index++) {
069 if (index > 0) {
070 url.append(',');
071 }
072 if (paramValues[index] != null) {
073 url.append(encode(paramValues[index].toString()));
074 }
075 }
076 url.append('&');
077 }
078 }
079
080 protected static void appendUrlParameter(StringBuilder url, String paramKey, Date paramValue, boolean includeTime) {
081 if (paramValue != null) {
082 String format = (includeTime ? "yyyy-MM-dd'T'HH:mm:ssZ" : "yyyy-MM-dd");
083 url.append(paramKey)
084 .append('=')
085 .append(encode(WSUtils.getINSTANCE().format(paramValue, format)))
086 .append('&');
087 }
088 }
089 }